#!/bin/bash

# check.sh
# check a python file using pylint and pep8

# debug mode:
#set -x

if [ $# != 1 ]; then
    echo "Unexpected number of args, just want a single python file"
    exit 1
fi

# look for test in guest tests
test_file=
if [ -f "$1" ]; then
    test_file="$1"
fi

# look for test in guest tests
if [ -f "$1.py" ]; then
    test_file="$1.py"
fi

# error if not found yet
if [ "$test_file" = "" ]; then
    echo "Could not find $1!"
    exit 2
fi

# run pylint
echo "pylint:"
pylint --reports=no $test_file
pylint_return=$?
echo

# run pep8
echo "pep8:"
pep8 "$test_file"
pep8_return=$?
echo

# done
echo Done checking
if [[ $pylint_return == 0 && $pep8_return == 0 ]]; then
    echo "Everything seems to be fine"
else
    echo "Please correct"
fi
