#!/usr/bin/env python

# The software in this package is distributed under the GNU General
# Public License version 2 (with a special exception described below).
#
# A copy of GNU General Public License (GPL) is included in this distribution,
# in the file COPYING.GPL.
#
# As a special exception, if other files instantiate templates or use macros
# or inline functions from this file, or you compile this file and link it
# with other works to produce a work based on this file, this file
# does not by itself cause the resulting work to be covered
# by the GNU General Public License.
#
# However the source code for this file must still be made available
# in accordance with section (3) of the GNU General Public License.
#
# This exception does not invalidate any other reasons why a work based
# on this file might be covered by the GNU General Public License.

"""
Module name: Summary of this module

Some overview over important classes and functions and such should be specified
in this docstring, but please keep it brief!


.. seealso:: http://thomas-cokelaer.info/tutorials/sphinx/rest_syntax.html
.. todo:: Do not forget to correct the codeauthor and license text commented by
          hashes above.
.. note:: You should note this
.. warning:: This is a warning

.. codeauthor:: John Doe, john.doe@intra2net.com
"""

THE_CONSTANT = None
""" some constant with docstring *AFTER* the constant. Use this format! """


ANOTHER_CONSTANT = 1     #: short docstring in same line -- note the #:

#: constant with docstring in line above it -- note the #:
THIRD_CONST = 3.333


class TestClass:
    """
    test class

    does nothing, really
    """

    def __init__(self, args):
        """ constructor, gets its own paragraph in documentation

        :raises NotImplementedError: always
        """
        raise NotImplementedError()

    def test_method(self, arg):
        """ test method, does nothing

        for more doc string examples, see function :py:func:`send_message`

        :param arg: some argument
        :return: Nothing
        :raises NotImplementedError: always
        """
        raise NotImplementedError()
# end: class TestClass


def send_message(sender, recipient, message_body, priority=1):
    """ Send a message to a recipient

    Example for a docstring that uses lots of reST fields, taken from
    http://sphinx-doc.org/domains.html

    Does not use :py:class:`TestClass` at all. Also has nothing to do with
    the python module :py:mod:`logging.handlers`

    Note that it is completely irrelevant what :py:data:`THE_CONSTANT` or
    :py:data:`ANOTHER_CONSTANT` or :py:data:`THIRD_CONSTANT` are set to. I just
    wanted to insert a link to a constant somewhere and find out how to
    document constants

    :param str sender: The person sending the message
    :param str recipient: The recipient of the message
    :param str message_body: The body of the message
    :param priority: The priority of the message, can be a number 1-5
    :type priority: integer or None
    :return: the message id
    :rtype: int
    :raises ValueError: if the message_body exceeds 160 characters
    :raises TypeError: if the message_body is not a basestring
    :raises NotImplementedError: always
    """

    raise NotImplementedError()


def main():
    """ Main function, called when running file as script

    currently raises a NotImplementedError
    """
    raise NotImplementedError
# end: function main


if __name__ == '__main__':
    main()
